
import it.vola.sms.GatewayConnector;
import it.vola.sms.GatewayResponse;
import it.vola.sms.GatewayResponse.GatewayStatus;
import it.vola.sms.Sender;
import it.vola.sms.Sms;

import java.util.ArrayList;

public class TestVolaSmsGw {

    public static void main(String[] args) {

        GatewayConnector gw = new GatewayConnector();

        //versione della classe
        System.out.println("VERSIONE: " + gw.getVersion());

        // Username e pwd sono case sensitive
        gw.setUsername("xxxxx");
        gw.setPassword("yyyyy");

        gw.setTestMode(false);

        gw.setSslConnection(true);
        gw.setNotify(false);

        gw.setLongMessage(true);

        //Test credito residuo
        testGetSMSCredit(gw);
        
        // TEST INVIO SMS MULTIPLO
//               testInvioMultiplo(gw);

        // TEST INVIO SMS SINGOLO
       // testInvioSingolo(gw);

        // TEST INVIO SMS ERRATO
//               testInvioErrato(gw);

// TEST GESTIONE MITTENTI
        // AGGIUNGO MITTENTE
//               testAggiungiMittente("pippo4", "pippo srl", "Via levanto, 45 Palermo", "IT", "0123xxxxxxx", "0123xxxxxxx", "02xxxxxx" , "02xxxxxxx", "+39323xxxxxxxx", "pippo@email.it",  gw);

        // ELENCO MITTENTI
            //   testGetListaMittenti(gw);

        // ELIMINO MITTENTE
//        testDeleteMittente("pippo4", gw);

        // AGGIUNGO MITTENTE NUMERO DI CELLULARE
//              testAggiungiMittenteCell("0039347xxxxxxx", gw);

        //AUTENTICO MITTENTE NUMERO DI CELLULARE

//             testAutenticaMittente("0039347xxxxxxx", "CH0P3B", gw);


// GET SMS AUTORESPONDER
//             testGetAutoresponder("chliave2",gw);
        // SET autoresponder
//             testSetAutoresponder("chliave2","Prova testo autoresponder è+è+è+è+è", gw);

        // DISATTIVA AUTORESPONDER
//             testDisattivaAutoresponder("chliave2",gw);


        // TEST RICEZIONE NUMERO SMS MO
//        testCheckRicezioneSMS(gw);

        // TEST RICEZIONE SMS MO
//        testRicezioneSMS(gw);


    }

    public static void testGetSMSCredit(GatewayConnector gw) {
        double credit = gw.getCredit();
        System.out.println("Credito residuo: " + credit);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }

    public static void testInvioSingolo(GatewayConnector gw) {
        GatewayResponse send_res = gw.sendSms("mittente", "+39347xxxxxxx", "test sms", "2013-12-03", "15:00");
        if (send_res.getStatus() == GatewayStatus.GW_CMD_OK) {

            System.out.println("INVIO AVVENUTO CON SUCCESSO - ORDERID: " + send_res.getOrderId());
            System.out.println(send_res.toString());
        } else {
            System.out.println(send_res.toString());
        }
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }

    public static void testInvioMultiplo(GatewayConnector gw) {
        GatewayResponse send_res = gw.sendSms("DEFAULT", "+39346xxxxxxx,+39347xxxxxxx", "prova invio sms", "2013-12-03", "15:00");
        if (send_res.getStatus() == GatewayStatus.GW_CMD_OK) {
            System.out.println("INVIO AVVENUTO CON SUCCESSO - ORDERID: " + send_res.getOrderId());
            System.out.println(send_res.toString());
        } else {
            System.out.println(send_res.toString());
        }
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }

    public static void testInvioErrato(GatewayConnector gw) {
        GatewayResponse send_res = gw.sendSms("DEFAULT", "xxxxxxxxx,yyyyyyyy", "test errato", "2013-01-04", "15:00");
        if (send_res.getStatus() == GatewayStatus.GW_CMD_OK) {
            System.out.println("INVIO AVVENUTO CON SUCCESSO - ORDERID: " + send_res.getOrderId());
            System.out.println(send_res.toString());
        } else {
            System.out.println(send_res.toString());
        }
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }

    public static void testAggiungiMittente(String mittente, String ragSoc, String indirizzo, String nazione, String cF, String pI, String telefono , String fax, String telCellulare, String email, GatewayConnector gw) {
        boolean res_add_sender = gw.addSender(mittente, ragSoc, indirizzo, nazione, cF, pI, telefono , fax, telCellulare, email);
        System.out.println("Mittente aggiunto " + res_add_sender);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }
    
    public static void testAggiungiMittenteCell(String mittente, GatewayConnector gw) {
        boolean res_add_sender = gw.addSender(mittente);
        System.out.println("Mittente aggiunto " + res_add_sender);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }

    public static void testAutenticaMittente(String mittente, String pincode, GatewayConnector gw) {
        boolean res_add_sender = gw.authenticateSender(mittente, pincode);
        System.out.println("Mittente autenticato " + res_add_sender);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }

    public static void testGetListaMittenti(GatewayConnector gw) {

        // RECUPERO MITTENTI
        ArrayList<Sender> senders = gw.getSenderList();
        for (int i = 0; i < senders.size(); i++) {
            switch (senders.get(i).getType()) {
                case DEFAULT:
                    System.out.println("Mittente predefinito" + senders.get(i).getName());
                    break;
                case AUTHENTICATED:
                    System.out.println("Mittente autenticato" + senders.get(i).getName());
                    break;
                case TO_AUTHENTICATE:
                    System.out.println("Mittente da autenticare via PICODE" + senders.get(i).getName());
                    break;
                case VOLA:
                    System.out.println("Mittente Vola" + senders.get(i).getName());
                    break;
            }
        }
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }

    public static void testDeleteMittente(String mittente, GatewayConnector gw) {

        boolean res_del_sender = gw.deleteSender(mittente);
        System.out.println("Mittente eliminato " + res_del_sender);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }

    public static void testGetAutoresponder(String key, GatewayConnector gw) {
        String txt = gw.getAutoresponder(key);
        System.out.println("Testo autoresponder " + txt);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }

    public static void testSetAutoresponder(String key, String testo_auto, GatewayConnector gw) {
        boolean res_auto_resp = gw.setAutoresponder(key, testo_auto);
        System.out.println("Impostazione autoresponder " + res_auto_resp);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }

    public static void testDisattivaAutoresponder(String key, GatewayConnector gw) {
        boolean res_dis_auto_resp = gw.setAutoresponder(key, "");
        System.out.println("Disattivazione autoresponder " + res_dis_auto_resp);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());
    }

    public static void testCheckRicezioneSMS(GatewayConnector gw) {

        long num = gw.CheckIncomingMessages("");
        System.out.println("Numero messaggi MO presenti sul server " + num);
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }

    public static void testRicezioneSMS(GatewayConnector gw) {

        // RICHIEDO MO CON CHIAVE VUOTA
        ArrayList<Sms> sms_mo = gw.GetIncomingMessages("");
        System.out.println("MO restituiti: " + sms_mo.size());
        for (int i = 0; i < sms_mo.size(); i++) {
            //   System.out.println(sms_mo.get(i).toString());
        }
        System.out.println("Risposta ultimo comando: " + gw.getLastCommandResponse().toString());

    }
}
